<template>
  <main class='add-category container'>
    <h1>Добавление категории</h1>
    <base-input :id='"nameCategory"' v-model="nameCategory" :label='"Название"'/>
    <admin-button  @click.native='addCategory'>
      Добавить
    </admin-button>
    <div v-show='successfulAdd' class='successful-add'>
      <p>Категория успешно добавленна</p>
    </div>
    <div v-show='errorAdd' class='error-add'>
      <p>Категория уже существует</p>
    </div>
  </main>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import BaseInput from '../../components/base/BaseInput'
import AdminButton from '../../components/admin/AdminButton'
export default {
  components: { AdminButton, BaseInput },
  layout: 'admin',
  data() {
    return {
      nameCategory: '',
      successfulAdd: false,
      errorAdd: false,
    }
  },

  computed: {
    ...mapGetters({
      getCategory: "admin/getCategory"
    })
  },

  watch: {
    nameCategory() {
      this.successfulAdd = false
      this.errorAdd = false
    }
  },

  methods: {
    ...mapActions({
      setCategory: "admin/setCategory"
    }),

    addCategory() {
      if(!this.getCategory.find(item => item.name === this.nameCategory) && this.nameCategory.length) {
        this.setCategory({ name: this.nameCategory });
        this.nameCategory = '';
        this.$nextTick(() => { this.successfulAdd = true })
      } else {
        this.errorAdd = true
      }
    }
  },
}
</script>

<style lang='scss' scoped>
.add-category {
  min-height: calc(100vh - 49px);
  padding-top: 30px;

  h1 {
    color: #2f3941;
    font-size: 22px;
    font-weight: normal;
    margin-bottom: 45px;
  }

  button {
    margin: 45px 0;
  }
}

.successful-add {
  background: rgba(22,186,82,.05);
  border-radius: 4px;
  border: 1px solid #16ba52;
  padding: 20px;

  p {
    line-height: 14px;
    color: #777;
  }
}

.error-add {
  background: rgb(255, 171, 171);
  border-radius: 4px;
  border: 1px solid #ff5353;
  padding: 20px;

  p {
    line-height: 14px;
    color: #777;
  }
}
</style>
